/**
 * DrawParam_iPhone.h
 *
 *  Copyright(c) Live2D Inc. All rights reserved.
 *  [[ CONFIDENTIAL ]]
 */
#ifndef __LIVE2D_DRAWPARAM_IPHONE_H__
#define __LIVE2D_DRAWPARAM_IPHONE_H__


#ifndef __SKIP_DOC__

#include "../Live2D.h"

#ifdef L2D_TARGET_IPHONE

#include <OPENGLES/ES1/gl.h>
#include "DrawParam.h"

//------------ LIVE2D NAMESPACE ------------
namespace live2d
{ 
	
	class DrawParam_iPhone : public DrawParam 
	{
	public:
		DrawParam_iPhone();
		virtual ~DrawParam_iPhone();
		
	public:
		virtual void drawTexture( int textureNo  , int indexCount , int vertexCount , l2d_index * indexArray 
								 , l2d_pointf * vertexArray , l2d_uvmapf * uvArray , float opacity, int colorCompositionType) ;
	
		void setTexture( int modelTextureNo , GLuint textureNo ) ;
	
		//  新しく利用できるModelのテクスチャ番号を確保(Avatar用）
		virtual int generateModelTextureNo() ;
		
		//  Modelのテクスチャ番号を生成(Avatar用）
		virtual void releaseModelTextureNo(int no) ;
		
		virtual void setupDraw();

	private:
		// Prevention of copy Constructor
		DrawParam_iPhone( const DrawParam_iPhone & ) ;				
		DrawParam_iPhone& operator=( const DrawParam_iPhone & ) ; 	
	
	private:
		static const int DUMMY_GL_TEXTURE_NO = 9999 ;	//  generateした番号に立てるフラグ
		
	private:
        live2d::LDVector<GLuint>* 		texturesPtr ;				//  Destructorでテクスチャの解放は行わない。基本的に外部で行う。
	};
	
}
//------------ LIVE2D NAMESPACE ------------

#endif		// L2D_TARGET_IPHONE
#endif		// __SKIP_DOC__
#endif		// __LIVE2D_DRAWPARAM_IPHONE_H__
